<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Map"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: beta 1 / August 2009 ==

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php');

$directory = basename(dirname($_SERVER['PHP_SELF']));
$activeModules[$directory]['directory'] = $directory;

// Sprache
$translator->addTranslation('map',CPO_BASEDIR.$activeModules[$directory]['directory'].'/lang');

// Seitenausgabe ********************************************************
include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/producer.inc.php');

// Header
require(CPO_BASEDIR.'_include/header.php');

printPageHeader(
	__('Map'),
	__('In this view you can search for location coordinates.'),
	'http://manual.conpresso4.de/gmap/application.htm',
	true,
	'modules'
);




echo '<form name="geosearchform" action="places.php">';
echo '<p>'.__('Please fill in zip-code or city:').' <br />';
echo '<input type="text" name="geosrch" value="'.$_REQUEST['geosrch'].'"> ';
echo '<input type="submit" value="'.__('search').'"></p>';

$_REQUEST['geosrch'] = trim($_REQUEST['geosrch']);

$placesFile = 'places.txt';
$placesFile = 'OrteBundesland.txt';
$placesFile = $activeModules[$directory]['placesFile'];

if ($_REQUEST['geosrch']) {
	$placesContent = file(CPO_BASEDIR.$activeModules[$directory]['directory'].'/places/'.$placesFile);

	foreach ($placesContent AS $placeNr => $placeData)  {
		$place = explode(';', trim($placeData));
		$plz[$placeNr]  = $place[3];
		$plzD[$placeNr] = sprintf("%05s",$place[3]);
		$ort[$placeNr]  = $place[0];
		$lat[$placeNr]  = $place[1];
		$lng[$placeNr]  = $place[2];
	}
	if ((int)$_REQUEST['geosrch'] != 0)  { // PLZ Eingabe
		foreach ($plz AS $no => $singlePLZ)  {
			if (substr($singlePLZ,0,strlen($_REQUEST['geosrch'])) == $_REQUEST['geosrch']) {
				$match[$plz[$no].$ort[$no].$lat[$no].$lng[$no]] = $no;
			}
		}
		if (!is_array($match))  { // PLZ nicht gefunden
			$minLength = strlen($_REQUEST['geosrch']);
			$noZipMatch = true;
			for($len=4;$len>0;$len--)  {
				if (is_array($match)) break;
				foreach ($plz AS $no => $singlePLZ)  {
					if (substr($singlePLZ,0,$len) == substr($_REQUEST['geosrch'],0,$len) && strlen($singlePLZ) >= $minLength) {
						$match[$plz[$no].$ort[$no].$lat[$no].$lng[$no]] = $no;
					}
				}
			}
		}
	} elseif ((int)$_REQUEST['geosrch'] == 0)  { // Text Eingabe
		foreach ($ort AS $no => $singleORT)  {
			if (strtolower(substr($singleORT,0,strlen($_REQUEST['geosrch']))) == strtolower($_REQUEST['geosrch'])) {
				$match[$plz[$no].$ort[$no].$lat[$no].$lng[$no]] = $no;
			}
		}
	}

	if (is_array($match)) {
		if (count($match)>1)  {
			if ($noZipMatch) echo '<p>'.__('No exact match was found.<br />Please choose from the list showing the nearest matches:').'<br />';
			else echo '<p>'.__('More than one match was found.<br />Please choose from the list:').'<br />';
			echo '<select name="geoselect" onChange="document.geosearchform.submit();">';
			foreach ($match AS $matchNr)  {
				$selected = ($matchNr == $_REQUEST['geoselect']) ? ' selected="selected"' : '' ;
				echo '<option value="'.$matchNr.'"'.$selected.'>'.$plz[$matchNr].' '.$ort[$matchNr].'</option>';
			}
			echo '</select> ';
			echo '<input type="submit" value="'.__('select').'"></p>';
			$selectBoxShown = true;
		} else {
			$_REQUEST['geoselect'] = implode('',$match);
		}
	} else {
		$message[] = __('No matches found!');
		include(CPO_BASEDIR.'_include/message.php');
	}

	echo '</form>';

	include(CPO_BASEDIR.'_include/message.php');

	if ($_REQUEST['geoselect']) {
		$matchNr = (int)$_REQUEST['geoselect'];
	if ($noZipMatch && !$selectBoxShown) echo '<p>'.__('No exact match was found.<br />The nearest match:').'<p/>';
		?>

	<p><TABLE>
	<TR>
		<TD><?php echo __('Zip-code / city'); ?>:</TD>
		<TD><?php echo $plz[$matchNr]; ?> <?php echo $ort[$matchNr]; ?></TD>
	</TR>
	<TR>
		<TD><?php echo __('Latitude'); ?>:</TD>
		<TD><B><?php echo $lat[$matchNr]; ?></B></TD>
	</TR>
	<TR>
		<TD><?php echo __('Longitude'); ?>:</TD>
		<TD><B><?php echo $lng[$matchNr]; ?></B></TD>
	</TR>
	</TABLE></p>

	<?php

	echo '<form>';
	echo '<input type="submit" value="'.__('start a new search').'"></p>';
	echo '</form>';
	}
}

// ==== footer =====
include(CPO_BASEDIR.'_include/footer.php');

?>
